 GLTransitions = [{
			"name": "Sniper_Scope",
			"shotcut": true,
			"paramsTypes": {
					"Mag_Index"      : "float",
					"Scope_Diameter" : "float",
					"Scope_Coords"   : "vec2",
					"Scope_Color"    : "vec4",
					"Scope_Thickness": "float",
					"Scope_Only"     : "bool",
					"Cross_Hairs"    : "bool"
			},
			"defaultParams": {
					"Mag_Index"      : 1.0,
					"Scope_Diameter" : 0.666,
					"Scope_Coords"   : [0.5, 0.6],
					"Scope_Color"    : [0.1, 0.1, 0.2, 1.0],
					"Scope_Thickness": 0.04,
					"Scope_Only"     : false,
					"Cross_Hairs"    : true
 
			},
			"glsl": "// Sniper_Scope \n// License: MIT \n// Author: Elusien (www.elusien.co.uk/shotcut)\n uniform vec2  Scope_Coords;   //= vec2(0.5, 0.5);            // Normalised coordinates of scope\n uniform float Scope_Diameter; //= 0.333;                     // Normalises diameter of scope (1.0 = video height)\n uniform vec4  Scope_Color;    //= vec4(0.18, 0.18, 0.3, 1,0);// Colour of the scope (normalised RGBA)\n uniform float Mag_Index;      //= 1.0;						  // Degree of magnification (0.0 to 1.0)\n uniform float Scope_Thickness;//= 0.04;					  // Scope thickness fraction of scope diameter)\n uniform bool  Cross_Hairs;    //= true;					  // true = scope cross-hairs are shown\n uniform bool  Scope_Only;     //= false; 				      // true = only image within scope is shown\n\n// Optimisation Routines - Courtesy of Daniel Holden (http://theorangeduck.com/page/avoiding-shader-conditionals)\nfloat when_eq (float x, float y) {return 1.0 - abs(sign(x - y));}\nfloat when_neq(float x, float y) {return       abs(sign(x - y));}\nfloat when_gt (float x, float y) {return       max(sign(x - y), 0.0);}\nfloat when_lt (float x, float y) {return       max(sign(y - x), 0.0);}\nfloat when_ge (float x, float y) {return 1.0 - when_lt(x, y);}\nfloat when_le (float x, float y) {return 1.0 - when_gt(x, y);}\nvec2  when_eq (vec2  x, vec2  y) {return 1.0 - abs(sign(x - y));}\nvec2  when_neq(vec2  x, vec2  y) {return       abs(sign(x - y));}\nvec2  when_gt (vec2  x, vec2  y) {return       max(sign(x - y), 0.0);}\nvec2  when_lt (vec2  x, vec2  y) {return       max(sign(y - x), 0.0);}\nvec2  when_ge (vec2  x, vec2  y) {return 1.0 - when_lt(x, y);}\nvec2  when_le (vec2  x, vec2  y) {return 1.0 - when_gt(x, y);}\nvec3  when_eq (vec3  x, vec3  y) {return 1.0 - abs(sign(x - y));}\nvec3  when_neq(vec3  x, vec3  y) {return       abs(sign(x - y));}\nvec3  when_gt (vec3  x, vec3  y) {return       max(sign(x - y), 0.0);}\nvec3  when_lt (vec3  x, vec3  y) {return       max(sign(y - x), 0.0);}\nvec3  when_ge (vec3  x, vec3  y) {return 1.0 - when_lt(x, y);}\nvec3  when_le (vec3  x, vec3  y) {return 1.0 - when_gt(x, y);}\nvec4  when_eq (vec4  x, vec4  y) {return 1.0 - abs(sign(x - y));}\nvec4  when_neq(vec4  x, vec4  y) {return       abs(sign(x - y));}\nvec4  when_gt (vec4  x, vec4  y) {return       max(sign(x - y), 0.0);}\nvec4  when_lt (vec4  x, vec4  y) {return       max(sign(y - x), 0.0);}\nvec4  when_ge (vec4  x, vec4  y) {return 1.0 - when_lt(x, y);}\nvec4  when_le (vec4  x, vec4  y) {return 1.0 - when_gt(x, y);}\n\nfloat and     (float a, float b) {return     a * b      ;}\nfloat or      (float a, float b) {return min(a + b, 1.0);}\nfloat xor     (float a, float b) {return mod(a + b, 2.0);}\nfloat not     (float a         ) {return     1.0 - a    ;}\nvec2  and     (vec2  a, vec2  b) {return     a * b      ;}\nvec2  or      (vec2  a, vec2  b) {return min(a + b, 1.0);}\nvec2  xor     (vec2  a, vec2  b) {return mod(a + b, 2.0);}\nvec2  not     (vec2  a         ) {return     1.0 - a    ;}\nvec3  and     (vec3  a, vec3  b) {return     a * b      ;}\nvec3  or      (vec3  a, vec3  b) {return min(a + b, 1.0);}\nvec3  xor     (vec3  a, vec3  b) {return mod(a + b, 2.0);}\nvec3  not     (vec3  a         ) {return     1.0 - a    ;}\nvec4  and     (vec4  a, vec4  b) {return     a * b      ;}\nvec4  or      (vec4  a, vec4  b) {return min(a + b, 1.0);}\nvec4  xor     (vec4  a, vec4  b) {return mod(a + b, 2.0);}\nvec4  not     (vec4  a         ) {return     1.0 - a    ;}\n\nvec4 transition(vec2 p) { \n	vec2  SC          = vec2(Scope_Coords.x, (1.0 - Scope_Coords.y)); \n	float SD          = Scope_Diameter / ratio;			// Scope-Diameter as a fraction of frame height\n	float SR          = SD * 0.5;						// Scope-Radius.\n	float ST          = Scope_Diameter * Scope_Thickness;\n	float R           = Scope_Diameter + (1.0 - Mag_Index) * (1.0 - Scope_Diameter);\n	float CH          = float(Cross_Hairs);\n	float CT          = CH * ST * 0.5;					// Cross-Hair thickness\n	float RT          = CT * 0.25;						// Reticule thickness\n	vec4  Retic_Color = vec4(1.0, 0.0, 0.0, 1.0);		// Reticule color (Red)\n	float NotSO       = not(float(Scope_Only));\n	float hr          = R - R*sqrt(R - (SD*SD)/R);\n	vec2  xy          = p - SC.xy;						// this point relative to scope centre.\n	float rr          = sqrt(xy.x * xy.x * (ratio * ratio) + xy.y * xy.y);\n	float rr_lt_SD    = when_lt(rr, SD);\n	float ok2color    = or(NotSO, rr_lt_SD);			// 0 = Black, 1 = color\n	\n// Majority of the scene should be outside the scope (return color or Black).\n	if (rr >= SD) { return vec4(vec3(ok2color), 1.0) * getFromColor(SC.xy + xy); }\n\n// Below this line we are either on or inside the scope. Use the optimisation routines instad of IF THEN ELSE	\n	float use_scope_colr =	or(\n								when_gt(rr, SD-ST), CH * or(\n									and(when_lt(abs(xy.x * ratio), CT), when_gt(abs(xy.y        ), SR)),\n									and(when_lt(abs(xy.y        ), CT), when_gt(abs(xy.x * ratio), SR))\n								)	\n							);\n	float use_retic_colr =	\n							CH * or(\n									and(when_lt(abs(xy.x * ratio), RT), when_le(abs(xy.y        ), SR)),\n									and(when_lt(abs(xy.y        ), RT), when_le(abs(xy.x * ratio), SR))\n	\n							);\n	\n	float RR_gt_rr = when_gt(R , rr);\n	float sqrt_arg = not(RR_gt_rr) * progress + RR_gt_rr * (R * R - rr * rr);	// prevent sqrt of -ve number error (<progress> is used simply to stop warning messages about it)\n	vec4  colr     = getFromColor(SC.xy + xy * (R - hr) * inversesqrt(sqrt_arg));\n\n	return use_scope_colr * Scope_Color + \n	       use_retic_colr * Retic_Color +\n		   and(not(use_scope_colr), not(use_retic_colr)) * vec4(vec3(ok2color), 1.0) * colr;\n\n}\n\n",
			"license": "MIT",
			"createdAt": "Wed, 30 Apr 2019 17:01:45 +0000",
			"updatedAt": "Thu, 30 Apr 2019 17:01:45 +0000"
	}
];

GLTransitionsByName = {};
GLTransitionNames   = [];
GLTransitionNamesLC = [];

GLTransitions.forEach(function(element) {
	GLTransitionsByName     [element.name.toLowerCase()] = element;
	GLTransitionNamesLC.push(element.name.toLowerCase());
	GLTransitionNames  .push(element.name              );
	
});

GLTransitionNamesLC.sort();
GLTransitionNames  .sort(function(a,b){return a.localeCompare(b);});

function getFilterParameters(webvfx) {
// Gets the shader UNIFORM parameters from the Shotcut FILTER properties
		
//console.log('====' + typeof webvfx + ', ' + typeof webvfx.getNumberParameter);

		if ((typeof webvfx                    === 'undefined') ||
		(typeof webvfx.getNumberParameter === 'undefined')) {
			return undefined;
	}
	
	var color = webvfx.getStringParameter('color').substring(1);
//console.log('========= color=' + color);
	if (typeof color === 'undefined') { return undefined; }
	
	var fp = {
		Scope_Diameter  :   webvfx.getNumberParameter('diameter'     ),
		Mag_Index       :   webvfx.getNumberParameter('magnification'),
		Scope_Thickness :   webvfx.getNumberParameter('thickness'    ),
		Cross_Hairs     :   webvfx.getNumberParameter('cross_hairs'  ),
		Scope_Only      :   webvfx.getNumberParameter('scope_only'   ),
		Scope_Coords    : [
							webvfx.getNumberParameter('x_pos'        ),
							webvfx.getNumberParameter('y_pos'        )
						  ],
		Scope_Color     : [
							(parseInt(color.substring(0,2),16) / 255).toFixed(3),
							(parseInt(color.substring(2,4),16) / 255).toFixed(3),
							(parseInt(color.substring(4  ),16) / 255).toFixed(3),
							1.0
						  ]
	};
//console.log('======= fp.Scope_Color=' + fp.Scope_Color);
	return fp;
	
}


